// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from smacc2_msgs:msg/SmaccEvent.idl
// generated code does not contain a copyright notice
#include "smacc2_msgs/msg/detail/smacc_event__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `event_type`
// Member `event_object_tag`
// Member `event_source`
// Member `label`
#include "rosidl_runtime_c/string_functions.h"

bool
smacc2_msgs__msg__SmaccEvent__init(smacc2_msgs__msg__SmaccEvent * msg)
{
  if (!msg) {
    return false;
  }
  // event_type
  if (!rosidl_runtime_c__String__init(&msg->event_type)) {
    smacc2_msgs__msg__SmaccEvent__fini(msg);
    return false;
  }
  // event_object_tag
  if (!rosidl_runtime_c__String__init(&msg->event_object_tag)) {
    smacc2_msgs__msg__SmaccEvent__fini(msg);
    return false;
  }
  // event_source
  if (!rosidl_runtime_c__String__init(&msg->event_source)) {
    smacc2_msgs__msg__SmaccEvent__fini(msg);
    return false;
  }
  // label
  if (!rosidl_runtime_c__String__init(&msg->label)) {
    smacc2_msgs__msg__SmaccEvent__fini(msg);
    return false;
  }
  return true;
}

void
smacc2_msgs__msg__SmaccEvent__fini(smacc2_msgs__msg__SmaccEvent * msg)
{
  if (!msg) {
    return;
  }
  // event_type
  rosidl_runtime_c__String__fini(&msg->event_type);
  // event_object_tag
  rosidl_runtime_c__String__fini(&msg->event_object_tag);
  // event_source
  rosidl_runtime_c__String__fini(&msg->event_source);
  // label
  rosidl_runtime_c__String__fini(&msg->label);
}

bool
smacc2_msgs__msg__SmaccEvent__are_equal(const smacc2_msgs__msg__SmaccEvent * lhs, const smacc2_msgs__msg__SmaccEvent * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // event_type
  if (!rosidl_runtime_c__String__are_equal(
      &(lhs->event_type), &(rhs->event_type)))
  {
    return false;
  }
  // event_object_tag
  if (!rosidl_runtime_c__String__are_equal(
      &(lhs->event_object_tag), &(rhs->event_object_tag)))
  {
    return false;
  }
  // event_source
  if (!rosidl_runtime_c__String__are_equal(
      &(lhs->event_source), &(rhs->event_source)))
  {
    return false;
  }
  // label
  if (!rosidl_runtime_c__String__are_equal(
      &(lhs->label), &(rhs->label)))
  {
    return false;
  }
  return true;
}

bool
smacc2_msgs__msg__SmaccEvent__copy(
  const smacc2_msgs__msg__SmaccEvent * input,
  smacc2_msgs__msg__SmaccEvent * output)
{
  if (!input || !output) {
    return false;
  }
  // event_type
  if (!rosidl_runtime_c__String__copy(
      &(input->event_type), &(output->event_type)))
  {
    return false;
  }
  // event_object_tag
  if (!rosidl_runtime_c__String__copy(
      &(input->event_object_tag), &(output->event_object_tag)))
  {
    return false;
  }
  // event_source
  if (!rosidl_runtime_c__String__copy(
      &(input->event_source), &(output->event_source)))
  {
    return false;
  }
  // label
  if (!rosidl_runtime_c__String__copy(
      &(input->label), &(output->label)))
  {
    return false;
  }
  return true;
}

smacc2_msgs__msg__SmaccEvent *
smacc2_msgs__msg__SmaccEvent__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  smacc2_msgs__msg__SmaccEvent * msg = (smacc2_msgs__msg__SmaccEvent *)allocator.allocate(sizeof(smacc2_msgs__msg__SmaccEvent), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(smacc2_msgs__msg__SmaccEvent));
  bool success = smacc2_msgs__msg__SmaccEvent__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
smacc2_msgs__msg__SmaccEvent__destroy(smacc2_msgs__msg__SmaccEvent * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    smacc2_msgs__msg__SmaccEvent__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
smacc2_msgs__msg__SmaccEvent__Sequence__init(smacc2_msgs__msg__SmaccEvent__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  smacc2_msgs__msg__SmaccEvent * data = NULL;

  if (size) {
    data = (smacc2_msgs__msg__SmaccEvent *)allocator.zero_allocate(size, sizeof(smacc2_msgs__msg__SmaccEvent), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = smacc2_msgs__msg__SmaccEvent__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        smacc2_msgs__msg__SmaccEvent__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
smacc2_msgs__msg__SmaccEvent__Sequence__fini(smacc2_msgs__msg__SmaccEvent__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      smacc2_msgs__msg__SmaccEvent__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

smacc2_msgs__msg__SmaccEvent__Sequence *
smacc2_msgs__msg__SmaccEvent__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  smacc2_msgs__msg__SmaccEvent__Sequence * array = (smacc2_msgs__msg__SmaccEvent__Sequence *)allocator.allocate(sizeof(smacc2_msgs__msg__SmaccEvent__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = smacc2_msgs__msg__SmaccEvent__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
smacc2_msgs__msg__SmaccEvent__Sequence__destroy(smacc2_msgs__msg__SmaccEvent__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    smacc2_msgs__msg__SmaccEvent__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
smacc2_msgs__msg__SmaccEvent__Sequence__are_equal(const smacc2_msgs__msg__SmaccEvent__Sequence * lhs, const smacc2_msgs__msg__SmaccEvent__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!smacc2_msgs__msg__SmaccEvent__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
smacc2_msgs__msg__SmaccEvent__Sequence__copy(
  const smacc2_msgs__msg__SmaccEvent__Sequence * input,
  smacc2_msgs__msg__SmaccEvent__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(smacc2_msgs__msg__SmaccEvent);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    smacc2_msgs__msg__SmaccEvent * data =
      (smacc2_msgs__msg__SmaccEvent *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!smacc2_msgs__msg__SmaccEvent__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          smacc2_msgs__msg__SmaccEvent__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!smacc2_msgs__msg__SmaccEvent__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
