// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from smacc2_msgs:msg/SmaccTransitionLogEntry.idl
// generated code does not contain a copyright notice
#include "smacc2_msgs/msg/detail/smacc_transition_log_entry__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `timestamp`
#include "builtin_interfaces/msg/detail/time__functions.h"
// Member `transition`
#include "smacc2_msgs/msg/detail/smacc_transition__functions.h"

bool
smacc2_msgs__msg__SmaccTransitionLogEntry__init(smacc2_msgs__msg__SmaccTransitionLogEntry * msg)
{
  if (!msg) {
    return false;
  }
  // timestamp
  if (!builtin_interfaces__msg__Time__init(&msg->timestamp)) {
    smacc2_msgs__msg__SmaccTransitionLogEntry__fini(msg);
    return false;
  }
  // transition
  if (!smacc2_msgs__msg__SmaccTransition__init(&msg->transition)) {
    smacc2_msgs__msg__SmaccTransitionLogEntry__fini(msg);
    return false;
  }
  return true;
}

void
smacc2_msgs__msg__SmaccTransitionLogEntry__fini(smacc2_msgs__msg__SmaccTransitionLogEntry * msg)
{
  if (!msg) {
    return;
  }
  // timestamp
  builtin_interfaces__msg__Time__fini(&msg->timestamp);
  // transition
  smacc2_msgs__msg__SmaccTransition__fini(&msg->transition);
}

bool
smacc2_msgs__msg__SmaccTransitionLogEntry__are_equal(const smacc2_msgs__msg__SmaccTransitionLogEntry * lhs, const smacc2_msgs__msg__SmaccTransitionLogEntry * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // timestamp
  if (!builtin_interfaces__msg__Time__are_equal(
      &(lhs->timestamp), &(rhs->timestamp)))
  {
    return false;
  }
  // transition
  if (!smacc2_msgs__msg__SmaccTransition__are_equal(
      &(lhs->transition), &(rhs->transition)))
  {
    return false;
  }
  return true;
}

bool
smacc2_msgs__msg__SmaccTransitionLogEntry__copy(
  const smacc2_msgs__msg__SmaccTransitionLogEntry * input,
  smacc2_msgs__msg__SmaccTransitionLogEntry * output)
{
  if (!input || !output) {
    return false;
  }
  // timestamp
  if (!builtin_interfaces__msg__Time__copy(
      &(input->timestamp), &(output->timestamp)))
  {
    return false;
  }
  // transition
  if (!smacc2_msgs__msg__SmaccTransition__copy(
      &(input->transition), &(output->transition)))
  {
    return false;
  }
  return true;
}

smacc2_msgs__msg__SmaccTransitionLogEntry *
smacc2_msgs__msg__SmaccTransitionLogEntry__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  smacc2_msgs__msg__SmaccTransitionLogEntry * msg = (smacc2_msgs__msg__SmaccTransitionLogEntry *)allocator.allocate(sizeof(smacc2_msgs__msg__SmaccTransitionLogEntry), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(smacc2_msgs__msg__SmaccTransitionLogEntry));
  bool success = smacc2_msgs__msg__SmaccTransitionLogEntry__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
smacc2_msgs__msg__SmaccTransitionLogEntry__destroy(smacc2_msgs__msg__SmaccTransitionLogEntry * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    smacc2_msgs__msg__SmaccTransitionLogEntry__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
smacc2_msgs__msg__SmaccTransitionLogEntry__Sequence__init(smacc2_msgs__msg__SmaccTransitionLogEntry__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  smacc2_msgs__msg__SmaccTransitionLogEntry * data = NULL;

  if (size) {
    data = (smacc2_msgs__msg__SmaccTransitionLogEntry *)allocator.zero_allocate(size, sizeof(smacc2_msgs__msg__SmaccTransitionLogEntry), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = smacc2_msgs__msg__SmaccTransitionLogEntry__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        smacc2_msgs__msg__SmaccTransitionLogEntry__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
smacc2_msgs__msg__SmaccTransitionLogEntry__Sequence__fini(smacc2_msgs__msg__SmaccTransitionLogEntry__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      smacc2_msgs__msg__SmaccTransitionLogEntry__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

smacc2_msgs__msg__SmaccTransitionLogEntry__Sequence *
smacc2_msgs__msg__SmaccTransitionLogEntry__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  smacc2_msgs__msg__SmaccTransitionLogEntry__Sequence * array = (smacc2_msgs__msg__SmaccTransitionLogEntry__Sequence *)allocator.allocate(sizeof(smacc2_msgs__msg__SmaccTransitionLogEntry__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = smacc2_msgs__msg__SmaccTransitionLogEntry__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
smacc2_msgs__msg__SmaccTransitionLogEntry__Sequence__destroy(smacc2_msgs__msg__SmaccTransitionLogEntry__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    smacc2_msgs__msg__SmaccTransitionLogEntry__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
smacc2_msgs__msg__SmaccTransitionLogEntry__Sequence__are_equal(const smacc2_msgs__msg__SmaccTransitionLogEntry__Sequence * lhs, const smacc2_msgs__msg__SmaccTransitionLogEntry__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!smacc2_msgs__msg__SmaccTransitionLogEntry__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
smacc2_msgs__msg__SmaccTransitionLogEntry__Sequence__copy(
  const smacc2_msgs__msg__SmaccTransitionLogEntry__Sequence * input,
  smacc2_msgs__msg__SmaccTransitionLogEntry__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(smacc2_msgs__msg__SmaccTransitionLogEntry);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    smacc2_msgs__msg__SmaccTransitionLogEntry * data =
      (smacc2_msgs__msg__SmaccTransitionLogEntry *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!smacc2_msgs__msg__SmaccTransitionLogEntry__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          smacc2_msgs__msg__SmaccTransitionLogEntry__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!smacc2_msgs__msg__SmaccTransitionLogEntry__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
